<?php
/**
 * Kunena Component
 * @package Kunena.Administrator
 * @subpackage Controllers
 *
 * @copyright (C) 2008 - 2014 Kunena Team. All rights reserved.
 * @license http://www.gnu.org/copyleft/gpl.html GNU/GPL
 * @link http://www.kunena.org
 **/
defined ( '_JEXEC' ) or die ();

/**
 * Kunena Users Controller
 *
 * @since 2.0
 */
class KunenaAdminControllerUsertypes extends KunenaController {
	protected $baseurl = null;

	public function __construct($config = array()) {
		parent::__construct($config);
		$this->baseurl = 'administrator/index.php?option=com_kunena&view=usertypes';
	}

  function add()
  {
    $this->app->setUserState ('kunena.usertypes.object', null);
    
    $this->setRedirect(KunenaRoute::_($this->baseurl."&layout=edit", false));
  }

	function edit() {
		if (! JSession::checkToken('post')) {
			$this->app->enqueueMessage ( JText::_ ( 'COM_KUNENA_ERROR_TOKEN' ), 'error' );
			$this->setRedirect(KunenaRoute::_($this->baseurl, false));
			return;
		}

		$cid = JRequest::getVar('cid', array(), 'post', 'array'); // Array of integers
		$id = array_shift($cid);

    $xml = simplexml_load_file(JPATH_ADMINISTRATOR . '/components/com_kunena/models/usertypes.xml');

    $object = new stdClass();
    foreach ($xml->children() as $attr) {
      if((int)$attr->action->attributes()->id==$id)
      {
        $object->id = $id;
        $object->name = (string)$attr->action->attributes()->name;
        $object->title = (string)$attr->action->attributes()->title;
        $object->joomla_group_id = (int)$attr->action->attributes()->joomla_group_id;
        $object->display_whoisonline  = (int)$attr->action->attributes()->display_whoisonline; 
        $object->rank_image = (int)$attr->action->attributes()->rankid_associated; 
      }
     
    }
    
    $this->app->setUserState ('kunena.usertypes.object', $object);

		$this->setRedirect(JRoute::_("index.php?option=com_kunena&view=usertypes&layout=edit", false));
	}

	function save() {    
    if (! JSession::checkToken('post')) {
			$this->app->enqueueMessage ( JText::_ ( 'COM_KUNENA_ERROR_TOKEN' ), 'error' );
			$this->setRedirect(KunenaRoute::_($this->baseurl, false));
			return;
		}

		$usertype_name = JRequest::getString('usertype_name');
		$usertype_languagestring = JRequest::getString('usertype_languagestring');
		$usertype_groupid = JRequest::getInt('usertype_groupid', 0);
    $display_whoisonline = JRequest::getInt('display_whoisonline', 0);
    $rank_image = JRequest::getInt('rank_image', 0);;
		$id = JRequest::getInt('id', 0);
    
    $xml = simplexml_load_file(JPATH_ADMINISTRATOR . '/components/com_kunena/models/usertypes.xml');
    
    if ( $id==0 )
    {
      $lastid = 0;
      foreach ($xml->children() as $attr) {
        foreach ( $attr->children() as $sub_attr) {
          $lastid = $sub_attr['id'];
        }
      }
      
      $lastid = $lastid+1;
      
      $type = $xml->addChild('types');
      $action = $type->addChild('action');
      $action->addAttribute('id', $lastid);
      $action->addAttribute('name', $usertype_name);
      $action->addAttribute('title', $usertype_languagestring);
      $action->addAttribute('joomla_group_id', $usertype_groupid );
      $action->addAttribute('display_whoisonline', $display_whoisonline );
      $action->addAttribute('rankid_associated', $rank_image );
       
      $result = $xml->asXML(JPATH_ADMINISTRATOR . '/components/com_kunena/models/usertypes.xml');
    
    }
    else
    {
      foreach ($xml->children() as $attr) {
        if((int)$attr->action->attributes()->id==$id)
        {
          $attr->action->attributes()->name = $usertype_name;
          $attr->action->attributes()->title = $usertype_languagestring;
          $attr->action->attributes()->joomla_group_id = $usertype_groupid; 
          $attr->action->attributes()->display_whoisonline = $display_whoisonline;
          $attr->action->attributes()->rankid_associated = $rank_image;
        }     
      }
      
      $result = $xml->asXML(JPATH_ADMINISTRATOR . '/components/com_kunena/models/usertypes.xml');                                                               // 
      
    }
    			
		if ( !$result ) {
		  $this->app->enqueueMessage ( JText::_ ( 'COM_KUNENA_USERTYPE_SAVED_FAILED' ), 'error');
		} else {
			$this->app->enqueueMessage ( JText::_ ( 'COM_KUNENA_USERTYPE_SAVED_SUCCESSFULLY' ) );
		}
    			
		$this->setRedirect(KunenaRoute::_($this->baseurl, false));   
	}

	function trashusermessages() {
		if (! JSession::checkToken('post')) {
			$this->app->enqueueMessage ( JText::_ ( 'COM_KUNENA_ERROR_TOKEN' ), 'error' );
			$this->setRedirect(KunenaRoute::_($this->baseurl, false));
			return;
		}

		$cid = JRequest::getVar('cid', array(), 'post', 'array'); // Array of integers
		JArrayHelper::toInteger($cid);

		if ($cid) {
			foreach($cid as $id) {
				list($total, $messages) = KunenaForumMessageHelper::getLatestMessages(false, 0, 0, array('starttime'=> '-1','user' => $id));
				foreach($messages as $mes) {
					$mes->publish(KunenaForum::DELETED);
				}
			}
		} else {
			$this->app->enqueueMessage ( JText::_('COM_KUNENA_PROFILE_NO_USER'), 'error' );
			$this->setRedirect(KunenaRoute::_($this->baseurl, false));
			return;
		}

		$this->app->enqueueMessage ( JText::_('COM_KUNENA_A_USERMES_TRASHED_DONE') );
		$this->setRedirect(KunenaRoute::_($this->baseurl, false));
	}

	function move() {
		if (! JSession::checkToken('post')) {
			$this->app->enqueueMessage ( JText::_ ( 'COM_KUNENA_ERROR_TOKEN' ), 'error' );
			$this->setRedirect(KunenaRoute::_($this->baseurl, false));
			return;
		}

		$cid = JRequest::getVar('cid', array(), 'post', 'array'); // Array of integers
		JArrayHelper::toInteger($cid);

		if ( empty($cid) ) {
			$this->app->enqueueMessage ( JText::_('COM_KUNENA_PROFILE_NO_USER'), 'error' );
			$this->setRedirect(KunenaRoute::_($this->baseurl, false));
			return;
		}

		$this->app->setUserState ( 'kunena.usermove.userids', $cid );

		$this->setRedirect(JRoute::_("index.php?option=com_kunena&view=user&layout=move", false));
	}

	function movemessages () {
		if (! JSession::checkToken('post')) {
			$this->app->enqueueMessage ( JText::_ ( 'COM_KUNENA_ERROR_TOKEN' ), 'error' );
			$this->setRedirect(KunenaRoute::_($this->baseurl, false));
			return;
		}

		$catid = JRequest::getInt('catid');
		$uids = (array) $this->app->getUserState ( 'kunena.usermove.userids' );

		$error = null;
		if ($uids) {
			foreach($uids as $id) {
				list($total, $messages) = KunenaForumMessageHelper::getLatestMessages(false, 0, 0, array('starttime'=> '-1','user' => $id));

				foreach($messages as $object) {
					$topic = $object->getTopic();

					if (!$object->authorise ( 'move' )) {
						$error = $object->getError();
					} else {
						$target = KunenaForumCategoryHelper::get( $catid );
						if (!$topic->move ( $target, false, false, '', false )) {
							$error = $topic->getError();
						}
					}
				}
			}

		} else {
			$this->app->enqueueMessage ( JText::_('COM_KUNENA_PROFILE_NO_USER'), 'error' );
			$this->setRedirect(KunenaRoute::_($this->baseurl, false));
			return;
		}

		if ($error) {
			$this->app->enqueueMessage ( $error, 'notice' );
		} else {
			$this->app->enqueueMessage ( JText::_('COM_KUNENA_A_USERMES_MOVED_DONE') );
		}
		$this->setRedirect(KunenaRoute::_($this->baseurl, false));
	}

	function logout() {
		if (! JSession::checkToken('post')) {
			$this->app->enqueueMessage ( JText::_ ( 'COM_KUNENA_ERROR_TOKEN' ), 'error' );
			$this->setRedirect(KunenaRoute::_($this->baseurl, false));
			return;
		}

		$cid = JRequest::getVar('cid', array(), 'post', 'array'); // Array of integers
		JArrayHelper::toInteger($cid);
		$id = array_shift($cid);

		if ($id <= 0 ) {
			$this->app->enqueueMessage ( JText::_('COM_KUNENA_PROFILE_NO_USER'), 'error' );
			$this->setRedirect(KunenaRoute::_($this->baseurl, false));
			return;
		}

		$options = array('clientid'=>0); // Just logout from site
		$this->app->logout( (int) $id, $options);

		$this->app->enqueueMessage ( JText::_('COM_KUNENA_A_USER_LOGOUT_DONE') );
		$this->setRedirect(KunenaRoute::_($this->baseurl, false));
	}

	function remove() {
		if (! JSession::checkToken('post')) {
			$this->app->enqueueMessage ( JText::_ ( 'COM_KUNENA_ERROR_TOKEN' ), 'error' );
			$this->setRedirect(KunenaRoute::_($this->baseurl, false));
			return;
		}

		$cid = JRequest::getVar('cid', array(), 'post', 'array'); // Array of integers
		JArrayHelper::toInteger($cid);
        
    $xml = simplexml_load_file(JPATH_ADMINISTRATOR . '/components/com_kunena/models/usertypes.xml');
    
    foreach ($xml->children() as $attr) {
      $id = (int)$attr->action->attributes()->id;
      
      if(in_array($id, $cid))
      {
          echo 'id '.$id.' ';
          
          $dom=dom_import_simplexml($attr);
          $dom->parentNode->removeChild($dom);
          
          $xml->asXML(JPATH_ADMINISTRATOR . '/components/com_kunena/models/usertypes.xml');
                    
          /*$attr->action->attributes()->name = $usertype_name;
          $attr->action->attributes()->title = $usertype_languagestring;
          $attr->action->attributes()->joomla_group_id = $usertype_groupid; 
          $attr->action->attributes()->display_whoisonline = $display_whoisonline;
          $attr->action->attributes()->rankid_associated = $rank_image;*/
      }     
    }
      
    /*
    
    foreach($cid as $id)
    {
      echo $id;
    }  */
    
    die(); 

		//$this->setRedirect(KunenaRoute::_($this->baseurl, false));
	}

	function ban() {
		if (! JSession::checkToken('post')) {
			$this->app->enqueueMessage ( JText::_ ( 'COM_KUNENA_ERROR_TOKEN' ), 'error' );
			$this->setRedirect(KunenaRoute::_($this->baseurl, false));
			return;
		}

		$cid = JRequest::getVar('cid', array(), 'post', 'array'); // Array of integers
		JArrayHelper::toInteger($cid);
		$userid = array_shift($cid);

		if ($userid <= 0 ) {
			$this->app->enqueueMessage ( JText::_('COM_KUNENA_PROFILE_NO_USER'), 'error' );
			$this->setRedirect(KunenaRoute::_($this->baseurl, false));
			return;
		}

		$ban = KunenaUserBan::getInstanceByUserid ( $userid, true );
		if (! $ban->id) {
			$ban->ban ( $userid, null, 0 );
			$success = $ban->save ();
		} else {
			jimport ('joomla.utilities.date');
			$now = new JDate();
			$ban->setExpiration ( $now );
			$success = $ban->save ();
		}

		$message = JText::_ ( 'COM_KUNENA_USER_BANNED_DONE' );

		if (! $success) {
			$this->app->enqueueMessage ( $ban->getError (), 'error' );
		} else {
			$this->app->enqueueMessage ( $message );
		}

		$this->setRedirect(KunenaRoute::_($this->baseurl, false));
	}

	function unban() {
		if (! JSession::checkToken('post')) {
			$this->app->enqueueMessage ( JText::_ ( 'COM_KUNENA_ERROR_TOKEN' ), 'error' );
			$this->setRedirect(KunenaRoute::_($this->baseurl, false));
			return;
		}

		$cid = JRequest::getVar('cid', array(), 'post', 'array'); // Array of integers
		JArrayHelper::toInteger($cid);
		$userid = array_shift($cid);

		if ($userid <= 0 ) {
			$this->app->enqueueMessage ( JText::_('COM_KUNENA_PROFILE_NO_USER'), 'error' );
			$this->setRedirect(KunenaRoute::_($this->baseurl, false));
			return;
		}

		$ban = KunenaUserBan::getInstanceByUserid ( $userid, true );
		if (! $ban->id) {
			$ban->ban ( $userid, null, 0 );
			$success = $ban->save ();
		} else {
			jimport ('joomla.utilities.date');
			$now = new JDate();
			$ban->setExpiration ( $now );
			$success = $ban->save ();
		}

		$message = JText::_ ( 'COM_KUNENA_USER_UNBAN_DONE' );

		if (! $success) {
			$this->app->enqueueMessage ( $ban->getError (), 'error' );
		} else {
			$this->app->enqueueMessage ( $message );
		}

		$this->setRedirect(KunenaRoute::_($this->baseurl, false));
	}

	function block() {
		if (! JSession::checkToken('post')) {
			$this->app->enqueueMessage ( JText::_ ( 'COM_KUNENA_ERROR_TOKEN' ), 'error' );
			$this->setRedirect(KunenaRoute::_($this->baseurl, false));
			return;
		}

		$cid = JRequest::getVar('cid', array(), 'post', 'array'); // Array of integers
		JArrayHelper::toInteger($cid);
		$userid = array_shift($cid);

		if ($userid <= 0 ) {
			$this->app->enqueueMessage ( JText::_('COM_KUNENA_PROFILE_NO_USER'), 'error' );
			$this->setRedirect(KunenaRoute::_($this->baseurl, false));
			return;
		}

		$ban = KunenaUserBan::getInstanceByUserid ( $userid, true );
		if (! $ban->id) {
			$ban->ban ( $userid, null, 1 );
			$success = $ban->save ();
		} else {
			jimport ('joomla.utilities.date');
			$now = new JDate();
			$ban->setExpiration ( $now );
			$success = $ban->save ();
		}

		$message = JText::_ ( 'COM_KUNENA_USER_BLOCKED_DONE' );


		if (! $success) {
			$this->app->enqueueMessage ( $ban->getError (), 'error' );
		} else {
			$this->app->enqueueMessage ( $message );
		}

		$this->setRedirect(KunenaRoute::_($this->baseurl, false));
	}

	function unblock() {
		if (! JSession::checkToken('post')) {
			$this->app->enqueueMessage ( JText::_ ( 'COM_KUNENA_ERROR_TOKEN' ), 'error' );
			$this->setRedirect(KunenaRoute::_($this->baseurl, false));
			return;
		}

		$cid = JRequest::getVar('cid', array(), 'post', 'array'); // Array of integers
		JArrayHelper::toInteger($cid);
		$userid = array_shift($cid);

		if ($userid <= 0 ) {
			$this->app->enqueueMessage ( JText::_('COM_KUNENA_PROFILE_NO_USER'), 'error' );
			$this->setRedirect(KunenaRoute::_($this->baseurl, false));
			return;
		}

		$ban = KunenaUserBan::getInstanceByUserid ( $userid, true );
		if (! $ban->id) {
			$ban->ban ( $userid, null, 1 );
			$success = $ban->save ();
		} else {
			jimport ('joomla.utilities.date');
			$now = new JDate();
			$ban->setExpiration ( $now );
			$success = $ban->save ();
		}

		$message = JText::_ ( 'COM_KUNENA_USER_UNBLOCK_DONE' );

		if (! $success) {
			$this->app->enqueueMessage ( $ban->getError (), 'error' );
		} else {
			$this->app->enqueueMessage ( $message );
		}

		$this->setRedirect(KunenaRoute::_($this->baseurl, false));
	}

	public function batch_moderators() {
		if (! JSession::checkToken('post')) {
			$this->app->enqueueMessage ( JText::_ ( 'COM_KUNENA_ERROR_TOKEN' ), 'error' );
			$this->setRedirect(KunenaRoute::_($this->baseurl, false));
			return;
		}

		$cid = JRequest::getVar('cid', array(), 'post', 'array'); // Array of integers
		JArrayHelper::toInteger($cid);
		$catids = JRequest::getVar('catid', array(), 'post', 'array'); // Array of integers
		JArrayHelper::toInteger($catids);

		if ( empty($cid) ) {
			$this->app->enqueueMessage ( JText::_ ( 'COM_KUNENA_USERS_BATCH_NO_USERS_SELECTED' ), 'error' );
			$this->setRedirect(KunenaRoute::_($this->baseurl, false));
			return;
		}

		if ( empty($catids) ) {
			$this->app->enqueueMessage ( JText::_ ( 'COM_KUNENA_USERS_BATCH_NO_CATEGORIES_SELECTED' ), 'error' );
			$this->setRedirect(KunenaRoute::_($this->baseurl, false));
			return;
		}

		// Update moderator rights
		$categories = KunenaForumCategoryHelper::getCategories(false, false, 'admin');
		$users = KunenaUserHelper::loadUsers($cid);
		foreach ($users as $user) {
			foreach ($categories as $category) {
				if (in_array($category->id, $catids)) $category->setModerator($user, true);
			}
			// Global moderator is a special case
			if ($this->me->isAdmin() && in_array(0, $catids)) {
				KunenaAccess::getInstance()->setModerator(0, $user, true);
			}
		}

		$this->app->enqueueMessage ( JText::_ ( 'COM_KUNENA_USERS_SET_MODERATORS_DONE' ) );
		$this->setRedirect(KunenaRoute::_($this->baseurl, false));
	}

	/**
	 * Method to just redirect to main manager in case of use of cancel button
	 *
	 * @return void
	 *
	 * @since 3.1
	 */
	public function cancel()
	{
		$this->app->redirect(KunenaRoute::_($this->baseurl, false));
	}
}
